#! /usr/bin/perl
#
#$Author: martin $
#$Id: getstock.pl,v 1.2 2000/06/21 21:05:56 martin Exp $

#$VERSION = 0.1.1;

$Cfgfile = "$ENV{'HOME'}/.getstockrc";
# The configfile will be overridden with the first cmd-parameter

my $Offline = 0;

########################################################################  
package ConfigFile;
#
# The code and the comments of this package came from Gerard Hickey
# hickey@ctron.com. 
# I've added the question-marks to the regexp in _readfile - section
# description, so that it matches at the first equal-sign in line.
#
# I removed the use of Carp and changed the "croak"-calls to die-calls and
# "carp"-calls to "warn"-calls.
# The following parts of the module are removed in this script:
#
# - $Version RCS-vars and the Version method
# - method CreateSection
# - method Write
#


use strict;

sub new 
{
  my ($class, $file) = @_;
  my ($self);

  $self = { File 	=>  $file,
  	    Config	=>  &_readfile ($file)
	  };
	 
  bless $self, $class;
}

	       

sub Section
{
  my ($self, $sect) = @_;
  					       
  # looking to get a list of all sections
  return (keys %{$self->{Config}}) if (! $sect);
  
  return (keys %{$self->{Config}->{$sect}});
}


# sub CreateSection
# {
#   my ($self, $sect) = @_;
  
#   $self->{Config}->{$sect} = {};
# }


sub Parameter 
{
  my ($self, $sect, $param, $val) = @_;

  if (! ($sect && $param))  
    { die "Section and parameter not specified to Parameter method." };
    
  if ($val)
    { $self->{Config}->{$sect}->{$param} = $val };

  $self->{Config}->{$sect}->{$param};
}


# sub Write
# {
#   my ($self) = @_;
#   my ($tmpfile) = "/tmp/.conf.$$";
#   my ($sect);
  
#   # prepare to write the configuration file  
#   open (CONF, "< $self->{File}") || carp ("Can not read from configuration file: $self->{File}");
#   open (TMP, "> $tmpfile") || carp ("Can not write to temporary configuration file: $tmpfile");
  
#   while (<CONF>)
#   { 
#     # process a comment or blank line
#     if (/^\s*[#;]/ || /^\s*$/)
#     {  print TMP $_; next };
    		
#     # Is this a section header?
#     /^\s*\[\s*(.+)\s*\].*$/ && do
#     {
#       $sect = $1;
#       print TMP $_;
#       next;
#     };
    
#     # process definition
#     /^\s*(.+)\s*=\s*(.+)\s*$/ && do
#     {print "REGEX: $1, $2\n";
#       print TMP "$1 = $self->{Config}->{$sect}->{$1}\n";
#       delete $self->{Config}->{$sect}->{$1};
#     };
#   };
    
#   close (TMP);
#   close (CONF);

#   # backup the group file and copy the temp file into place
#   system ("/bin/cp $tmpfile $self->{File}");
#   unlink ($tmpfile);
  
# };


sub _readfile
{ 
  my ($file) = @_;
  my ($config, $section, $term, $def);
  
  $config = {};

  open (CONFIG, "<$file") || warn "Can not open configuration file ($file)\n";
  while (<CONFIG>)
  { 			 
    chomp;		# get rid of newline
    # blank lines and comments			 
    next if (/^\s*$/o);
    next if (/^\s*[#;]/);
    	      
    # special note about next two regular expressions.
    #
    #  We want to extract the text without any whitespace at the end. 
    #  But we could have white space in the text (so \S+ does not work).
    #  The (.+\S) accepts any formation of characters that is terminated
    #  by any other character other than white space.
    #
    #  Works great--trust me....
    #
    
    # Section declaration
    /^\s*\[\s*(.+\S)\s*\]/ && do 
    { 
      $section = &_cleanup ($1); 
    };
     
    # Section description			   
    /^\s*?(.+?\S)\s*?=\s*(.+\S)\s*$/ && do
    {
      $term = &_cleanup ($1);
      $def = &_cleanup ($2);
      
#      $def = 1 if ($def =~ /on|true/io);
      
      
      $config->{$section}->{$term} = $def;
    };
  
  };			      
  close (CONFIG);
   
  $config;
}

# 
# The _cleanup procedure takes an argument, and does some data
# santizing checks on the argument.
#

sub _cleanup
{
  my ($str) = @_;
  # If the string has quotes around it, do nothing other than remove the quotes.
  $str =~ /^"(.+)"$/o && return ($1);
  
  $str =~ s/\s/ /og;  		# make sure there are only spaces.
  $str =~ tr/ / /s;		# squeeze whitespace into one character.

  return ($str);
}


########################################################################
package Editfile;
# The code of EditFile came from my Module File::Edit (not on CPAN published).
# Here I cut the following methods:
# 
# I removed the use of Carp and changed the "croak"-calls to die-calls
# The following methods are cut
# - grep
# - delete

use strict;


sub new {
    my $class = shift;
    my $self  = { fname => shift };
    bless $self, $class;
}


sub _edit_open {
    my ($self) = shift;

    my $newfile = $self->{'fname'} . ".BAK";

    if (! -f $self->{'fname'}) { 
        open SOURCE, ">$self->{'fname'}";
    }

    open DRAIN, ">$newfile" or
         die "$!: ", $newfile;
    open SOURCE, "<$self->{'fname'}" or
         die "$!: ", $self->{'fname'};
}


sub _edit_close {
    my ($self) = shift;
    close DRAIN;
    close SOURCE;

    unlink $self->{'fname'} 
           or die "$!: ", $self->{'fname'}, ".\n";
    my $newfile = $self->{'fname'} . ".BAK";
    rename $newfile, $self->{'fname'}
           or die "$!: ", $newfile, ".\n";;
}

sub _read_open {
    my ($self) = shift;
    open SOURCE, "$self->{'fname'}";
}

sub _read_close {
    close SOURCE;
}


# getline returns the first line where regexp matches
# or the line Line Number
sub getline {
    my ($self, $regexp) = @_;
 
    $self->_read_open();
    if ($regexp =~ /\d+/ ) {                    # return line Line Number
        my $linenr = 0;
        foreach (<SOURCE>) {
            $linenr++;
            if ($regexp == $linenr) {
                $self->_read_close;
                return $_;
            }
        }
    } else {                                    # return hash-ref
        foreach (<SOURCE>) {
            if ( $_ =~ /$regexp/ ) {
                $self->_read_close();
                return $_;
            }
        }
    }
}


# delete the FIRST line where regexp matches and returns it.
# delete the line LineNr and returns it.
sub deleteline {
    my ($self, $regexp) = @_;
    my $retval;
    $self->_edit_open();
    if ($regexp =~ /^\d+$/) {     # Delete line by number
        my $linenr;
        foreach (<SOURCE>) {
            $linenr++;
            if ($regexp == $linenr) {
                $retval = $_;
                next;
            }
            print DRAIN $_;
        }
        $self->_edit_close();
        return $retval;
    } else {                    # Delete line by regexp
        foreach (<SOURCE>) {
            if ($_ =~ /$regexp/g) {
                $retval = $_; 
                next;
            }
            print DRAIN $_;
        }
        $self->_edit_close();
        return $retval;
    }
}

# insert line $iline
sub insert {
    my ($self, $iline, $lnumber) = @_;
    my $linenr = 0;

    $self->_edit_open();
    foreach (<SOURCE>) {
        $linenr++;
        if ($linenr == $lnumber) {
            print DRAIN $iline, "\n";
        }
        print DRAIN $_;
    }
    if ($lnumber == 0) {
        print DRAIN $iline, "\n";
    }
    $self->_edit_close();
}

########################################################################

########################################################################
package Stock;
# This class contains the attributes an methods for handling the
# shares
use LWP::UserAgent;
use strict; 


#use vars qw(@ISA);
#@ISA = qw(ConfigFile);

sub new {
    my ($pkg, $name, $cfgfile)  = @_;
    my $me = {};
    my $cfg = new ConfigFile($cfgfile);

    # $ConfigFile::Section($name) returns list of params in section
    foreach ($cfg->Section($name)){
        $me->{$_} = $cfg->Parameter($name, $_);
    }

    $me->{'logfile'} = $cfg->Parameter("main", "LOGFILE");
    $me->{'workdir'} = $cfg->Parameter("main", "WORKDIR");

    # build the whole url for the question
    my $pre = uc $me->{'server'} . "_PRE"; 
    my $url = uc $me->{'server'} . "_URL";
    my $suf = uc $me->{'server'} . "_SUF";
    $me->{'url'} = $cfg->Parameter("main", ${url} ) . 
                   $cfg->Parameter("main", ${pre} ) .
                   $me->{'wkn'} .
                   $cfg->Parameter("main", ${suf} );

    # set global mailto and msubject parameter
    if (! $me->{'mailto'}) {
        $me->{'mailto'}   = $cfg->Parameter("main", "MAILTO")   }
    if (! $me->{'msubject'}) {
        $me->{'msubject'} = $cfg->Parameter("main", "MSUBJECT") }

    bless $me, $pkg;
}


# Send an email to the address specified in "mailto".
# If limits are given send an email only 
sub mail_if_limit {
    my ($self) = shift;
    return 1 if (! $self->{'mailto'});
    return 2 if (!($self->{'lmin'} || $self->{'lmax'}));

    if (( $self->{'lmin'} && $self->{'rate'} <= $self->{'lmin'} )  || 
        ( $self->{'lmax'} && $self->{'rate'} >= $self->{'lmax'} ))    
    
    {
        use Mail::Send;
        if (! $self->{'msubject'}) {
            $self->{'msubject'} = "getstock: limit reached";
        }
        my $msg = Mail::Send->new(
                                  Subject => $self->{'msubject'},
                                  To      => $self->{'mailto'},
                                  );
        
        my $mailhandle = $msg->open("mail"); # open(): calls /usr/bin/mail
        print $mailhandle "$self->{'fname'}: $self->{'rate'}\n";
        $mailhandle->close();
    }

}


# fetch the current stock-rating and set parameter => values:
# content  => current data from server
# rate     => current rate
# ratey    => yesterday closing rate
# date     => date for this rating
sub fetch {
    my ($self) = shift;
    # fetch files from server
    my $ua = LWP::UserAgent->new();
    if ($Offline) { $self->{'url'} = "http://localhost/HTML/stocktest.csv"; }
    my $request  = HTTP::Request->new('GET', $self->{'url'});
    my $response = $ua->request($request);
    if (! $response->is_success()) {
        print STDERR "ERROR Code: ", $response->code(),
        " Message: ", $response->message(), "\n";
        next;
    }
    # $response->content() returns a string like:
    # "SAP",53.125,"4/4/2000","4:00PM",-1.375,55.8125,55.8125,49,2754300
    $self->{'content'} = $response->content();
    chop $self->{'content'};

    my @rate = split ",", $self->{'content'};
    $self->{'rate'}  = $rate[1];
    $self->{'ratey'} = $rate[7];

    # format date
    $rate[2] =~ s/"//g;                         # "
    if (! ($rate[2] =~ /^\d/)) {
        my ($day, $mon, $year) = (localtime(time))[3, 4, 5];
        $mon  += 1;
        $year += 1900;
        $day  = sprintf "%02d", $day;
        $mon  = sprintf "%02d", $mon;
        $rate[2] = join ".", ($day, $mon, $year);
    } else {
        my ($mon, $day, $year) = split "/", $rate[2];
        $day  = sprintf "%02d", $day;
        $mon  = sprintf "%02d", $mon;
        $rate[2] = join ".", ($day, $mon, $year);
    }
    $self->{'date'}  = $rate[2];
}


# ->Parameter('parametername'): returns the value of parametername
# ->Parameter('parametername', 'val'): set parameter to val
sub parameter {
    my ($self, $pname, $value) = @_;
    return $self->{$pname} if (! $value);
    $self->{$pname} = $value;
}


sub write {
    my ($self) = shift;

    my $workdir = "$ENV{'HOME'}/$self->{'workdir'}";
    # shall we create a logfile
    if ($self->{'logfile'}) {
        my $logfile = new Editfile("$workdir/$self->{'logfile'}");
        $logfile->insert($self->{'content'}, 0);
    }

    my $outfile = new Editfile("$workdir/$self->{'fname'}");
    $outfile->deleteline($self->{'date'});

    if ($self->{'number'}) {
        my $worth = $self->{'rate'} * $self->{'number'};
        $worth  = sprintf "%13.2f", $worth;
        $self->{'rate'}  = sprintf "%13.2f", $self->{'rate'};
        $outfile->insert("$self->{'date'}$self->{'rate'}$worth");
    } else {
        $self->{'rate'}  = sprintf "%13.2f", $self->{'rate'};
        $outfile->insert("$self->{'date'}$self->{'rate'}");
    }
}


sub _printp {
    my ($self) = shift;
    foreach (keys %$self) {
        print "P: $_, $self->{$_}\n";
    }
}


########################################################################
package main;
use Getopt::Std;
use strict;
use vars qw($Cfgfile %sharelist $sharelist $opt_f);

getopt('f');

if ($opt_f) { $Cfgfile = $opt_f }

my $cfg = new ConfigFile($Cfgfile);

# create share-objects and put the list in %sharelist
foreach ($cfg->Section) {
    my $sharename = $_;         # $sharelist->{$_} isn't ok. Why?
    next if (/main/);
    $sharelist->{$sharename} = new Stock($_, $Cfgfile); 
}

foreach (keys %$sharelist){
    my $share = $_;                       # $_ := name of the share 
    my $shref = $sharelist->{$share};     # $shref := ref to cur shareobj
    $shref->fetch();
    $shref->write();
    $shref->mail_if_limit;
#    $shref->_printp;
}
